#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

int bfs(int i,int n, vector<int> &from, vector<int> &to, vector<int> &next) {
	vector<int> v(n,-1);
	queue<int> q;
	vector<int>prev(n,-1);
	q.push(i);
	v[i] = 0;
	while (q.size()) {
		int cur = q.front();
		q.pop();
		for (int j = from[cur]; j !=-1; j=next[j]) {
			if (to[j] == prev[cur]) continue;
			if (v[to[j]]!=-1)
				return v[to[j]]+v[cur]+1;
			v[to[j]] = v[cur] + 1;
			prev[to[j]] = cur;
			q.push(to[j]);
			
		}
	}
	return 100000;
}

int main () {
	freopen("DRIVING.IN", "r", stdin);
	int t;
	cin >> t;
	while (t--) {
		int n, m; 
		cin >>n>>m;
		vector<int> from(n, -1);
		vector<int> to(2*m);
		vector<int> next(2*m);
		int a, b;
		for (int i =0; i <m; ++i) {
			cin >>a>>b;
			a--;
			b--;
			next[2*i] = from[a];
			to[2*i] = b;
			from[a] = 2*i;
			next[2*i+1] = from[b];
			to[2*i+1] = a;
			from[b] = 2*i+1;
		}

		int omin = 10000;
		for (int i = 0; i<n;++i) {
			omin = min(omin, bfs(i, n, from, to ,next));
		}
		cout<<omin;

		cout <<endl;
	};

	return 0;
}