
#pragma comment(linker, "/stack:10111222")

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

typedef unsigned char byte;
typedef unsigned int uint;
#define min(a,b) ( (a)<=(b) ? (a) : (b) )
#define max(a,b) ( (a)>=(b) ? (a) : (b) )

int alloced =0;

uint* alloc(int sz)
{
	alloced+=sz;
	if (alloced > (200 << 20)) throw;
	return new uint[sz];
}

char s[10 << 20];

struct BigNum
{
	uint* a;
	int sz;

	BigNum() {}

	BigNum(uint* a, int sz):a(a), sz(sz) {}

	bool IsNull() const
	{
		return a == NULL;
	}

	uint GetDigit(int pos) const
	{
		if (pos >= sz) return 0;
		return a[pos];
	}

	BigNum(uint x)
	{
		sz = 1;
		a = alloc(1);
		a[0] = x;
	}

	void Print() const
	{
		memset(s,0,sizeof(s));
		int j=0;
		for(int i=sz-1; i>=0; i--)
		{
			uint d = a[i];
			s[j++] ='0' + d / 100000000u;  d %= 100000000u;
			s[j++] ='0' + d / 10000000u ;  d %= 10000000u;
			s[j++] ='0' + d / 1000000u  ;  d %= 1000000u;
			s[j++] ='0' + d / 100000u   ;  d %= 100000u;
			s[j++] ='0' + d / 10000u    ;  d %= 10000u;
			s[j++] ='0' + d / 1000u     ;  d %= 1000u;
			s[j++] ='0' + d / 100u      ;  d %= 100u;
			s[j++] ='0' + d / 10u       ;  d %= 10u;
			s[j++] ='0' + d / 1u        ;  d %= 1u;
		}
		
		int k;
		for(k=0; k+1<j && s[k]=='0'; ) k++;
		printf("%s\n", &s[k]);
	}

};

#define Base 1000000000

const BigNum N0(0);
const BigNum N1(1);

BigNum Add(const BigNum &a, const BigNum &b)
{
	int m = max(a.sz, b.sz);
	uint* r = alloc(m+1);
	int rsz = 0;
	uint h = 0;
	for(int i=0; i<m+1; i++)
	{
		 h += a.GetDigit(i) + b.GetDigit(i);
		 r[i] = (h >= Base ? h-Base : h); //h % Base;
		 h = (h >= Base) ? 1 : 0; //h /= Base;
		 if (r[i] == 0 && i == m)
		 {
		 }
		 else
		 {
			 rsz++;
		 }
	}
	return BigNum ( r, rsz );
}

int a[200];
int b[200];
int aq, bq;

BigNum fc[100000+10][2];

const BigNum& f(int n, int m, bool lastWasMul)
{
	if (n==m) return lastWasMul ? N1 : N0;
	if (n > m) return N0;
	if (n*2LL > m) return N0;

	BigNum& res = fc[n][lastWasMul];
	if (!res.IsNull()) return res;

	res=N0;
	for(int i=0; i < aq; i++)
		res = Add(res, f(n+a[i], m, false));

	for(int i=0; i < bq; i++)
		res = Add(res, f(n*b[i], m, true));

	fc[n][lastWasMul] = res;
	return fc[n][lastWasMul];
};



void main()
{
	freopen("EQUALIZER.IN", "r", stdin);
	//freopen("EQUALIZER.OUT", "w", stdout);

	int T;
	scanf("%d\n", &T);
	for(; T--; )
	{
		int n,m,k,t;
		scanf("%d %d\n", &n, &m);
		
		scanf("%d", &k);
		aq=0;
		for(int i=0; i<k; i++)
		{
			scanf("%d", &t);
			for(int i=0; i<aq; i++)
				if (a[i] == t) goto k0;
			a[aq++] = t;
			k0:;
		}

		scanf("%d", &k);
		bq=0;
		for(int i=0; i<k; i++)
		{
			scanf("%d", &t);
			for(int i=0; i<bq; i++)
				if (b[i] == t) goto k1;
			b[bq++] = t;
			k1:;
		}

		memset(fc, 0, sizeof(fc));
		const BigNum& res = f(n,m,false);

		res.Print();
	}

	fclose(stdout);
}
